From mboxrd@z Thu Jan  1 00:00:00 1970
Return-Path: <gentoo-commits+bounces-1425516-garchives=archives.gentoo.org@lists.gentoo.org>
Received: from lists.gentoo.org (pigeon.gentoo.org [208.92.234.80])
	(using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256/256 bits)
	 key-exchange X25519 server-signature RSA-PSS (2048 bits))
	(No client certificate requested)
	by finch.gentoo.org (Postfix) with ESMTPS id 52B29158094
	for <garchives@archives.gentoo.org>; Fri,  5 Aug 2022 19:50:14 +0000 (UTC)
Received: from pigeon.gentoo.org (localhost [127.0.0.1])
	by pigeon.gentoo.org (Postfix) with SMTP id D86D2E0EA2;
	Fri,  5 Aug 2022 19:50:11 +0000 (UTC)
Received: from smtp.gentoo.org (woodpecker.gentoo.org [IPv6:2001:470:ea4a:1:5054:ff:fec7:86e4])
	(using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256/256 bits)
	 key-exchange X25519 server-signature RSA-PSS (4096 bits))
	(No client certificate requested)
	by pigeon.gentoo.org (Postfix) with ESMTPS id B392CE0EA2
	for <gentoo-commits@lists.gentoo.org>; Fri,  5 Aug 2022 19:50:11 +0000 (UTC)
Received: from oystercatcher.gentoo.org (unknown [IPv6:2a01:4f8:202:4333:225:90ff:fed9:fc84])
	(using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256/256 bits)
	 key-exchange X25519 server-signature RSA-PSS (4096 bits))
	(No client certificate requested)
	by smtp.gentoo.org (Postfix) with ESMTPS id 3CA8834116E
	for <gentoo-commits@lists.gentoo.org>; Fri,  5 Aug 2022 19:50:10 +0000 (UTC)
Received: from localhost.localdomain (localhost [IPv6:::1])
	by oystercatcher.gentoo.org (Postfix) with ESMTP id 7CA8C57A
	for <gentoo-commits@lists.gentoo.org>; Fri,  5 Aug 2022 19:50:07 +0000 (UTC)
From: "Michał Górny" <mgorny@gentoo.org>
To: gentoo-commits@lists.gentoo.org
Content-Transfer-Encoding: 8bit
Content-type: text/plain; charset=UTF-8
Reply-To: gentoo-dev@lists.gentoo.org, "Michał Górny" <mgorny@gentoo.org>
Message-ID: <1659728999.303bca3f7979786d1b43e894dfab12287b18a9c1.mgorny@gentoo>
Subject: [gentoo-commits] repo/gentoo:master commit in: sys-libs/llvm-libunwind/
X-VCS-Repository: repo/gentoo
X-VCS-Files: sys-libs/llvm-libunwind/llvm-libunwind-16.0.0.9999.ebuild
X-VCS-Directories: sys-libs/llvm-libunwind/
X-VCS-Committer: mgorny
X-VCS-Committer-Name: Michał Górny
X-VCS-Revision: 303bca3f7979786d1b43e894dfab12287b18a9c1
X-VCS-Branch: master
Date: Fri,  5 Aug 2022 19:50:07 +0000 (UTC)
Precedence: bulk
List-Post: <mailto:gentoo-commits@lists.gentoo.org>
List-Help: <mailto:gentoo-commits+help@lists.gentoo.org>
List-Unsubscribe: <mailto:gentoo-commits+unsubscribe@lists.gentoo.org>
List-Subscribe: <mailto:gentoo-commits+subscribe@lists.gentoo.org>
List-Id: Gentoo Linux mail <gentoo-commits.gentoo.org>
X-BeenThere: gentoo-commits@lists.gentoo.org
X-Auto-Response-Suppress: DR, RN, NRN, OOF, AutoReply
X-Archives-Salt: 579bf0b1-688a-4d73-83c8-6385752c43d5
X-Archives-Hash: 811e849df002914d9fcb16d42a719597

commit:     303bca3f7979786d1b43e894dfab12287b18a9c1
Author:     Michał Górny <mgorny <AT> gentoo <DOT> org>
AuthorDate: Fri Aug  5 19:48:43 2022 +0000
Commit:     Michał Górny <mgorny <AT> gentoo <DOT> org>
CommitDate: Fri Aug  5 19:49:59 2022 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=303bca3f

sys-libs/llvm-libunwind: Add 16.* live ebuilds

Signed-off-by: Michał Górny <mgorny <AT> gentoo.org>

 .../llvm-libunwind-16.0.0.9999.ebuild              | 123 +++++++++++++++++++++
 1 file changed, 123 insertions(+)

diff --git a/sys-libs/llvm-libunwind/llvm-libunwind-16.0.0.9999.ebuild b/sys-libs/llvm-libunwind/llvm-libunwind-16.0.0.9999.ebuild
new file mode 100644
index 000000000000..2abe825b0946
--- /dev/null
+++ b/sys-libs/llvm-libunwind/llvm-libunwind-16.0.0.9999.ebuild
@@ -0,0 +1,123 @@
+# Copyright 1999-2022 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=8
+
+CMAKE_ECLASS=cmake
+PYTHON_COMPAT=( python3_{8..11} )
+inherit cmake-multilib flag-o-matic llvm llvm.org python-any-r1 \
+	toolchain-funcs
+
+DESCRIPTION="C++ runtime stack unwinder from LLVM"
+HOMEPAGE="https://llvm.org/docs/ExceptionHandling.html"
+
+LICENSE="Apache-2.0-with-LLVM-exceptions || ( UoI-NCSA MIT )"
+SLOT="0"
+KEYWORDS=""
+IUSE="+clang debug static-libs test"
+REQUIRED_USE="test? ( clang )"
+RESTRICT="!test? ( test )"
+
+RDEPEND="
+	!sys-libs/libunwind
+"
+# llvm-6 for new lit options
+DEPEND="
+	>=sys-devel/llvm-6
+"
+BDEPEND="
+	clang? (
+		sys-devel/clang
+	)
+	!test? (
+		${PYTHON_DEPS}
+	)
+	test? (
+		$(python_gen_any_dep 'dev-python/lit[${PYTHON_USEDEP}]')
+	)
+"
+
+LLVM_COMPONENTS=( runtimes libunwind libcxx llvm/cmake cmake )
+LLVM_TEST_COMPONENTS=( libcxxabi llvm/utils/llvm-lit )
+llvm.org_set_globals
+
+python_check_deps() {
+	use test || return 0
+	has_version "dev-python/lit[${PYTHON_USEDEP}]"
+}
+
+multilib_src_configure() {
+	local use_compiler_rt=OFF
+	local libdir=$(get_libdir)
+
+	if use clang && ! tc-is-clang; then
+		# Only do this conditionally to allow overriding with
+		# e.g. CC=clang-13 in case of breakage
+		local -x CC=${CHOST}-clang
+		local -x CXX=${CHOST}-clang++
+		strip-unsupported-flags
+	fi
+
+	# link to compiler-rt
+	# https://github.com/gentoo/gentoo/pull/21516
+	if tc-is-clang; then
+		local compiler_rt=$($(tc-getCC) ${CFLAGS} ${CPPFLAGS} \
+		   ${LD_FLAGS} -print-libgcc-file-name)
+		if [[ ${compiler_rt} == *libclang_rt* ]]; then
+			use_compiler_rt=ON
+		fi
+	fi
+
+	local mycmakeargs=(
+		-DPython3_EXECUTABLE="${PYTHON}"
+		-DLLVM_ENABLE_RUNTIMES="libunwind"
+		-DLLVM_LIBDIR_SUFFIX=${libdir#lib}
+		-DLLVM_INCLUDE_TESTS=OFF
+		-DLIBUNWIND_ENABLE_ASSERTIONS=$(usex debug)
+		-DLIBUNWIND_ENABLE_STATIC=$(usex static-libs)
+		-DLIBUNWIND_INCLUDE_TESTS=$(usex test)
+		-DLIBUNWIND_INSTALL_HEADERS=ON
+
+		# support non-native unwinding; given it's small enough,
+		# enable it unconditionally
+		-DLIBUNWIND_ENABLE_CROSS_UNWINDING=ON
+
+		# avoid dependency on libgcc_s if compiler-rt is used
+		-DLIBUNWIND_USE_COMPILER_RT=${use_compiler_rt}
+	)
+	if use test; then
+		mycmakeargs+=(
+			-DLLVM_ENABLE_RUNTIMES="libunwind;libcxxabi;libcxx"
+			-DLLVM_EXTERNAL_LIT="${EPREFIX}/usr/bin/lit"
+			-DLLVM_LIT_ARGS="$(get_lit_flags)"
+			-DLIBUNWIND_LIBCXX_PATH="${WORKDIR}/libcxx"
+
+			-DLIBCXXABI_LIBDIR_SUFFIX=
+			-DLIBCXXABI_ENABLE_SHARED=OFF
+			-DLIBCXXABI_ENABLE_STATIC=ON
+			-DLIBCXXABI_USE_LLVM_UNWINDER=ON
+			-DLIBCXXABI_INCLUDE_TESTS=OFF
+
+			-DLIBCXX_LIBDIR_SUFFIX=
+			-DLIBCXX_ENABLE_SHARED=OFF
+			-DLIBCXX_ENABLE_STATIC=ON
+			-DLIBCXX_CXX_ABI=libcxxabi
+			-DLIBCXX_ENABLE_ABI_LINKER_SCRIPT=OFF
+			-DLIBCXX_HAS_MUSL_LIBC=$(usex elibc_musl)
+			-DLIBCXX_HAS_GCC_S_LIB=OFF
+			-DLIBCXX_INCLUDE_TESTS=OFF
+			-DLIBCXX_INCLUDE_BENCHMARKS=OFF
+		)
+	fi
+
+	cmake_src_configure
+}
+
+multilib_src_test() {
+	local -x LIT_PRESERVES_TMP=1
+	cmake_build check-unwind
+}
+
+multilib_src_install() {
+	DESTDIR=${D} cmake_build install-unwind
+}